/* (C) 2009-2011 Yana */

#if !defined(YANAMIPS_H)
#define YANAMIPS_H

#define YANAMIPS_VECTOR 0x180

#define YANAMIPS_BADVADDR $8
#define YANAMIPS_STATUS $12
#define YANAMIPS_CAUSE $13
#define YANAMIPS_EPC $14

#define YANAMIPS_HAZARD_BADVADDR
#define YANAMIPS_HAZARD_STATUS
#define YANAMIPS_HAZARD_CAUSE
#define YANAMIPS_HAZARD_EPC

#define YANAMIPS_STATUS_IM_MASK (0xff << YANAMIPS_STATUS_IM_SHIFT)
#define YANAMIPS_STATUS_IM_SHIFT 8
#define YANAMIPS_STATUS_EXL (1 << 1)
#define YANAMIPS_STATUS_IE (1 << 0)

#define YANAMIPS_CAUSE_BD (1 << 31)
#define YANAMIPS_CAUSE_IP_MASK (0xff << YANAMIPS_CAUSE_IP_SHIFT)
#define YANAMIPS_CAUSE_IP_SHIFT 8
#define YANAMIPS_CAUSE_EXCCODE_MASK (0x1f << YANAMIPS_CAUSE_EXCCODE_SHIFT)
#define YANAMIPS_CAUSE_EXCCODE_SHIFT 2

#define YANAMIPS_CAUSE_IP1 (0x02 << YANAMIPS_CAUSE_IP_SHIFT)
#define YANAMIPS_CAUSE_IP0 (0x01 << YANAMIPS_CAUSE_IP_SHIFT)

#define YANAMIPS_CAUSE_EXCCODE_INT (0x00 << YANAMIPS_CAUSE_EXCCODE_SHIFT)
#define YANAMIPS_CAUSE_EXCCODE_ADEL (0x04 << YANAMIPS_CAUSE_EXCCODE_SHIFT)
#define YANAMIPS_CAUSE_EXCCODE_ADES (0x05 << YANAMIPS_CAUSE_EXCCODE_SHIFT)
#define YANAMIPS_CAUSE_EXCCODE_SYS (0x08 << YANAMIPS_CAUSE_EXCCODE_SHIFT)

#endif
